// ;-*-C++-*- *  Time-stamp: "2008-10-16 03:40:57 hmmr"

/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny
 *
 * License: GPLv2 only
 *
 * Initial version: 2008-09-23
 *
 * A base class for integrators, to be plugged into CModel
 */


#ifndef CN_INTEGRATE_BASE_H
#define CN_INTEGRATE_BASE_H

class CModel;

class CIntegrate_base {

    public:
	bool is_owned;
	double	dt;  // that which is current

	CModel *model;

	CIntegrate_base( bool inis_owned)
		{
			is_owned = inis_owned;
		}

	virtual void cycle() = 0;
	virtual void prepare() = 0;
};



#endif

// EOF
