// ;-*-C++-*- *  Time-stamp: "2008-10-12 00:55:09 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny
 *
 * License: GPLv2 only
 *
 * Initial version: 2008-09-23
 *
 * A Runge-Kutta 6-5 integrator
 */


#ifndef CN_INTEGRATE_RK65_H
#define CN_INTEGRATE_RK65_H


#include "cnlib-integrate-base.h"
#include <vector>


class CIntegrateRK65
  : public CIntegrate_base {

	double	dt_max, dt_min, dt_max_safeguard_factor,
		eps, eps_abs, eps_rel;

    public:
	CIntegrateRK65( double indt_max = .1, double indt_min = 1e-6,  double indt_max_safeguard_fac = 5,
			double ineps = 1e-8,  double inepsabs = 1e-12, double inepsrel = 1e-6,
			bool inis_owned = true)
	      : CIntegrate_base( inis_owned)
		{
			dt_max = dt = indt_max, dt_min = indt_min, dt_max_safeguard_factor = indt_max_safeguard_fac,
			eps = ineps, eps_abs = inepsabs, eps_rel = inepsrel;
		}

	virtual void cycle();
	virtual void prepare();

    private:
	std::vector<double> Y[9], F[9], y5;
};

#endif

// EOF
