// ;-*-C++-*- *  Time-stamp: "2008-10-14 15:05:00 hmmr"
//--------------------------------------------------------------------------
// Author: Thomas Nowotny
//
// Institute: Institute for Nonlinear Dynamics
//            University of California San Diego
//            La Jolla, CA 92093-0402
//
// email to:  tnowotny@ucsd.edu
//
// initial version: 2005-08-17
//
//--------------------------------------------------------------------------


#ifndef CN_NEURONTIME_H
#define CN_NEURONTIME_H

#include "cnlib-unit.h"

extern const double __CN_Vars_NeuronTime[];
extern const char* const __CN_VarNames_NeuronTime[];
extern const char* const __CN_VarSyms_NeuronTime[];



class CNeuronTime
  : public CNeuron {

    public:
	CNeuronTime()
	      : CNeuron( NT_TICKER, "n_time", 0., 0., 0.)
		{}

	virtual void derivative( vector<double>& unused, vector<double>& dx)
		{ dE(dx) = 1.0; }
};

#endif

// EOF
