// ;-*-C++-*- *  Time-stamp: "2008-10-16 03:39:20 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny
 *
 * License: GPLv2 only
 *
 * Initial version: 2008-09-23
 *
 * CN global unit descriptors
 */



#include <cstring>
#include <iostream>
#include "cnlib-types.h"


extern const double __CN_Vars_NeuronTime[];
extern const char* const __CN_VarNames_NeuronTime[];
extern const char* const __CN_VarSyms_NeuronTime[];


extern const double __CN_Vars_NeuronReader[];
extern const char* const __CN_VarNames_NeuronReader[];
extern const char* const __CN_VarSyms_NeuronReader[];


extern const double __CN_Params_NeuronHH[];
extern const char* const __CN_ParamNames_NeuronHH[];
extern const char* const __CN_ParamSyms_NeuronHH[];

extern const double __CN_Vars_NeuronHH[];
extern const char* const __CN_VarNames_NeuronHH[];
extern const char* const __CN_VarSyms_NeuronHH[];


extern const double __CN_Params_NeuronTM[];
extern const char* const __CN_ParamNames_NeuronTM[];
extern const char* const __CN_ParamSyms_NeuronTM[];

extern const double __CN_Vars_NeuronTM[];
extern const char* const __CN_VarNames_NeuronTM[];
extern const char* const __CN_VarSyms_NeuronTM[];


extern const double __CN_Params_NeuronEC[];
extern const char* const __CN_ParamNames_NeuronEC[];
extern const char* const __CN_ParamSyms_NeuronEC[];

extern const double __CN_Vars_NeuronEC[];
extern const char* const __CN_VarNames_NeuronEC[];
extern const char* const __CN_VarSyms_NeuronEC[];


extern const double __CN_Params_NeuronECA[];
extern const char* const __CN_ParamNames_NeuronECA[];
extern const char* const __CN_ParamSyms_NeuronECA[];

extern const double __CN_Vars_NeuronECA[];
extern const char* const __CN_VarNames_NeuronECA[];
extern const char* const __CN_VarSyms_NeuronECA[];


extern const double __CN_Params_OscillatorLV[];
extern const char* const __CN_ParamNames_OscillatorLV[];
extern const char* const __CN_ParamSyms_OscillatorLV[];

extern const double __CN_Vars_OscillatorLV[];
extern const char* const __CN_VarNames_OscillatorLV[];
extern const char* const __CN_VarSyms_OscillatorLV[];


extern const double __CN_Params_OscillatorColpitts[];
extern const char* const __CN_ParamNames_OscillatorColpitts[];
extern const char* const __CN_ParamSyms_OscillatorColpitts[];

extern const double __CN_Vars_OscillatorColpitts[];
extern const char* const __CN_VarNames_OscillatorColpitts[];
extern const char* const __CN_VarSyms_OscillatorColpitts[];


extern const double __CN_Params_OscillatorVdPol[];
extern const char* const __CN_ParamNames_OscillatorVdPol[];
extern const char* const __CN_ParamSyms_OscillatorVdPol[];

extern const double __CN_Vars_OscillatorVdPol[];
extern const char* const __CN_VarNames_OscillatorVdPol[];
extern const char* const __CN_VarSyms_OscillatorVdPol[];


extern const double __CN_Params_OscillatorPoisson[];
extern const char* const __CN_ParamNames_OscillatorPoisson[];
extern const char* const __CN_ParamSyms_OscillatorPoisson[];

extern const double __CN_Vars_OscillatorPoisson[];
extern const char* const __CN_VarNames_OscillatorPoisson[];
extern const char* const __CN_VarSyms_OscillatorPoisson[];



extern const double __CN_Params_SynapseAb[];
extern const char* const __CN_ParamNames_SynapseAb[];
extern const char* const __CN_ParamSyms_SynapseAb[];

extern const double __CN_Vars_SynapseAb[];
extern const char* const __CN_VarNames_SynapseAb[];
extern const char* const __CN_VarSyms_SynapseAb[];




SCNDescriptor __CN_DescriptorTable[] = {

// ---------------- Neuron types

	{ 0, 1,  // NT_TIME
	  NULL,
	  NULL,
	  NULL,
	  __CN_Vars_NeuronTime,
	  __CN_VarNames_NeuronTime,
	  __CN_VarSyms_NeuronTime,
	  "Timer",
	  "Time unit"
	},

	{ 0, 1, // NT_TAPE
	  NULL,
	  NULL,
	  NULL,
	  __CN_Vars_NeuronReader,
	  __CN_VarNames_NeuronReader,
	  __CN_VarSyms_NeuronReader,
	  "Reader",
	  "Data sampler unit"
	},

	{ 8, 4,	 // NT_HH
	  __CN_Params_NeuronHH,
	  __CN_ParamNames_NeuronHH,
	  __CN_ParamSyms_NeuronHH,
	  __CN_Vars_NeuronHH,
	  __CN_VarNames_NeuronHH,
	  __CN_VarSyms_NeuronHH,
	  "HH",
	  "Hodgkin-Huxley Neuron"
	},

	{ 11, 4, // NT_TM
	  __CN_Params_NeuronTM,
	  __CN_ParamNames_NeuronTM,
	  __CN_ParamSyms_NeuronTM,
	  __CN_Vars_NeuronTM,
	  __CN_VarNames_NeuronTM,
	  __CN_VarSyms_NeuronTM,
	  "TM",
	  "Traub-Miles Neuron"
	},

	{ 14, 6, // NT_EC
	  __CN_Params_NeuronEC,
	  __CN_ParamNames_NeuronEC,
	  __CN_ParamSyms_NeuronEC,
	  __CN_Vars_NeuronEC,
	  __CN_VarNames_NeuronEC,
	  __CN_VarSyms_NeuronEC,
	  "EC",
	  "Entorhinal Cortex neuron"
	},

	{ 11, 7, // NT_ECA
	  __CN_Params_NeuronECA,
	  __CN_ParamNames_NeuronECA,
	  __CN_ParamSyms_NeuronECA,
	  __CN_Vars_NeuronECA,
	  __CN_VarNames_NeuronECA,
	  __CN_VarSyms_NeuronECA,
	  "ECA",
	  "Entorhinal Cortex (A) neuron"
	},

	{ 5, 2, // NT_POISSON,  // remembering: x[0] is the time // no, V[0] is E: V[1] is time now
	  __CN_Params_OscillatorPoisson,
	  __CN_ParamNames_OscillatorPoisson,
	  __CN_ParamSyms_OscillatorPoisson,
	  __CN_Vars_OscillatorPoisson,
	  __CN_VarNames_OscillatorPoisson,
	  __CN_VarSyms_OscillatorPoisson,
	  "Poisson",
	  "Poisson oscillator unit"
	},

	{ 2, 2, // NT_LV, // appears E is not part of ex-iVars
	  __CN_Params_OscillatorLV,
	  __CN_ParamNames_OscillatorLV,
	  __CN_ParamSyms_OscillatorLV,
	  __CN_Vars_OscillatorLV,
	  __CN_VarNames_OscillatorLV,
	  __CN_VarSyms_OscillatorLV,
	  "LV",
	  "Lotka-Volterra oscillator unit"
	},

	{ 4, 3, // NT_COLPITTS,
	  __CN_Params_OscillatorColpitts,
	  __CN_ParamNames_OscillatorColpitts,
	  __CN_ParamSyms_OscillatorColpitts,
	  __CN_Vars_OscillatorColpitts,
	  __CN_VarNames_OscillatorColpitts,
	  __CN_VarSyms_OscillatorColpitts,
	  "Colpitts",
	  "Colpitts oscillator unit"
	},

	{ 3, 2, // NT_VDPOL,
	  __CN_Params_OscillatorVdPol,
	  __CN_ParamNames_OscillatorVdPol,
	  __CN_ParamSyms_OscillatorVdPol,
	  __CN_Vars_OscillatorVdPol,
	  __CN_VarNames_OscillatorVdPol,
	  __CN_VarSyms_OscillatorVdPol,
	  "VdPol",
	  "Van der Pol oscillator unit"
	},

// ---------------- Synapse types

	{ 7, 1,  // YT_ABSYN
	  __CN_Params_SynapseAb,
	  __CN_ParamNames_SynapseAb,
	  __CN_ParamSyms_SynapseAb,
	  __CN_Vars_SynapseAb,
	  __CN_VarNames_SynapseAb,
	  __CN_VarSyms_SynapseAb,
	  "Ab",
	  "Ab synapse"
	},
	{ 0, 0,  // YT_OSCILTUNER
	  NULL, NULL, NULL,
	  NULL, NULL, NULL,
	  "OscilTuner",
	  "Oscillator Tuner"
	},
};






using namespace std;

void
cnmodel_dump_available_units()
{
	size_t u, p;
	cout << "\n===== Neurons:\n";
	for ( u = NT_FIRST; u <= NT_LAST; u++ ) {
		SCNDescriptor &U = __CN_DescriptorTable[u];
		cout << "--- [" << U.label << "] \"" << U.name << "\"\n"
		     << "Parameters: ---\n";
		for ( p = 0; p < U.pno; p++ ) {
			printf( "%4d: %-5s\t= % 8g\t // %s\n",
				p, U.stock_param_syms[p],
				U.stock_param_values[p],
				U.stock_param_names[p]);
		}
		cout << "Variables: ---\n";
		for ( p = 0; p < U.vno; p++ ) {
			printf( "%4d: %-5s\t= % 8g\t // %s\n",
				p, U.stock_var_syms[p],
				U.stock_var_values[p],
				U.stock_var_names[p]);
		}
		cout << endl;
	}
	cout << "\n===== Synapses:\n";
	for ( u = YT_FIRST; u <= YT_LAST; u++ ) {
		SCNDescriptor &U = __CN_DescriptorTable[u];
		cout << "--- [" << U.label << "] \"" << U.name << "\"\n"
		     << "Parameters: ---\n";
		for ( p = 0; p < U.pno; p++ ) {
			printf( "%4d: %-5s\t= % 8g\t // %s\n",
				p, U.stock_param_syms[p],
				U.stock_param_values[p],
				U.stock_param_names[p]);
		}
		cout << "Variables: ---\n";
		for ( p = 0; p < U.vno; p++ ) {
			printf( "%4d: %-5s\t= % 8g\t // %s\n",
				p, U.stock_var_syms[p],
				U.stock_var_values[p],
				U.stock_var_names[p]);
		}
		cout << endl;
	}
	cout << endl;
}



// EOF
