// ;-*-C++-*- *  Time-stamp: "2008-10-16 03:40:57 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny (tnowotny@ucsd.edu)
 *
 * License: GPLv2 only
 *
 * Initial version: 2008-08-02
 *
 */


#include "cnlib-unit.h"
#include "cnlib-model.h"

using namespace std;

CUnitCompare __CUnitCompareObject;

double __cn_dummy_double;

CNeuron::~CNeuron()
{
	vector<CSynapse*>::iterator iter;
	for ( iter = den.begin(); iter != den.end(); iter++ )
		(*iter) -> _target = NULL;
}


CSynapse::~CSynapse()
{
	if ( !_target )
		return;

	vector<CSynapse*>::iterator iter;
	for ( iter = _target->den.begin(); iter != _target->den.end(); iter++ )
		if ( (*iter) == this ) {
			_target->den.erase( iter);
			return;
		}
}



void
CUnit::start_listening()
{
	if ( !_listener ) {
		_listener = new ofstream( label);
		_listener->precision( 18);
		*_listener << "#time";
		for ( int v = 0; v < v_no(); v++ )
			*_listener << "\t<" << __CN_DescriptorTable[_type].stock_var_names[v] << ">";
		*_listener << endl;
		_status |= CN_ULISTENING;
	}

}
void
CUnit::stop_listening()
{
	if ( _listener ) {
		delete _listener;
		_listener = NULL;
		_status &= ~CN_ULISTENING;
	}
}



void
CUnit::tell()
{
	*_listener << model_time();  // also add a timestamp
	for ( size_t v = 0; v < v_no(); v++ )
		*_listener << "\t" << (*_parent_model->V)[idx + v];
	*_listener << endl;
}







double
CNeuron::Isyn( vector<double>&b)
{
	double I = 0.0;
	vector<CSynapse*>::iterator den_it;
	for ( den_it = den.begin(); den_it != den.end(); den_it++ )
		I += (*den_it) -> Isyn(b);
	return I;
}


// EOF
