// ;-*-C++-*- *  Time-stamp: "2008-07-28 04:04:24 hmmr"
/*--------------------------------------------------------------------------
   Author: Thomas Nowotny

   Institute: Institute for Nonlinear Dynamics
	      University of California San Diego
	      La Jolla, CA 92093-0402

   email to:  tnowotny@ucsd.edu

   initial version: 2005-08-18

--------------------------------------------------------------------------*/

#ifndef CN_NEURONMULTIFIRE_INPUT_H
#define CN_NEURONMULTIFIRE_INPUT_H

#include "CN_Neuron_input.h"

class CNeuronInputMultifire
  : public CNeuron_input {

    public:
	const double&     spkt()	{ return __CN_DescriptorTable[type()].stock_param_values[0]; }
	const double& rfp_spkt()	{ return __CN_DescriptorTable[type()].stock_param_values[1]; }
	const double&     Vrst()	{ return __CN_DescriptorTable[type()].stock_param_values[2]; }
	const double&     Vfir()	{ return __CN_DescriptorTable[type()].stock_param_values[3]; }
	const double&   period()	{ return __CN_DescriptorTable[type()].stock_param_values[4]; }

	CNeuronInputMultifire( TUnitType intype, int inlabel, vector<int>& pos)
	      : CNeuron_input( type, inlabel, inpos)
		{
			theE = Vrst();
			t_last = -1.0;
		}

	virtual double& E();
};


#endif

// EOF
