// ;-*-C++-*- *  Time-stamp: "2008-07-18 12:44:58 hmmr"
/*--------------------------------------------------------------------------
   Author: Thomas Nowotny

   Institute: Institute for Nonlinear Dynamics
	      University of California San Diego
	      La Jolla, CA 92093-0402

   email to:  tnowotny@ucsd.edu

   initial version: 2002-02-14

--------------------------------------------------------------------------*/



#include "CN_Neuron_input.h"



void CNeuron_input::init(double *x, double *iniVars)
{
  neuron::init(x,iniVars);
  theE= p[2];
  t_last= x[0]-1.0;
}

void CNeuron_input::set_input(int infno, double *intb,
			    double *inte, double instime= -1.0)
{
  if (instime > 0.0) p[4]= instime;
  fno= infno;             // no. of bursts in pattern
  if (fno > 0) {
    delete[] tb;
    delete[] te;
    tb= new double[fno];
    te= new double[fno];

    for (int i= 0; i < fno; i++)
    {
      intb[i]= intb[i] - ((int) ((intb[i])/p[4]))*p[4];
      tb[i]= intb[i];
      inte[i]= inte[i] - ((int) ((inte[i])/p[4]))*p[4];
      te[i]= inte[i];
    }
  }
}

// EOF
