// ;-*-C++-*- *  Time-stamp: "2008-07-18 03:34:36 hmmr"
/*--------------------------------------------------------------------------
   Author: Thomas Nowotny

   Institute: Institute for Nonlinear Dynamics
	      University of California San Diego
	      La Jolla, CA 92093-0402

   email to:  tnowotny@ucsd.edu

   initial version: 2002-02-14

--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------
   This an abstract class which is a wrapper for all types of input
   neurons (multifire_inputneuron, noisy input neuron etc)
--------------------------------------------------------------------------*/


#ifndef CN_NEURONINPUT_H
#define CN_NEURONINPUT_H

#include "CN_Neuron_base.h"

class CNeuron_input
  : public CNeuron_base {

    public:
	int fno;
	double *tb, *te;
	double theE, t_last;

	CNeuron_input( TNeuronType intype, int inlabel, vector<int>& pos)
	      : CNeuron_base( intype, inlabel, pos)  // has no type of its own, so passes intype down to base
		{
			tb = new double[1];
			te = new double[1];
			theE= p[2];  // this must be Vrst; but how do we know it at this point?
			t_last= -1.0;
//			setIdx(-1);
		}

       ~CNeuron_input()
		{
			delete[] tb;
			delete[] te;
		}

  virtual void init(double *, double *);
  virtual void set_input(int, double *, double *, double);
  virtual double E(double *)= 0;
  virtual void derivative(double *, double *) { }
};


#endif
