// ;-*-C++-*- *  Time-stamp: "2008-09-17 16:35:34 hmmr"
/*--------------------------------------------------------------------------
   Author: Thomas Nowotny

   Institute: Institute for Nonlinear Dynamics
	      University of California San Diego
	      La Jolla, CA 92093-0402

   email to:  tnowotny@ucsd.edu

   initial version: 2002-02-01

--------------------------------------------------------------------------*/

/*--------------------------------------------------------------------------

  random number generator, initializes with system time, returns a random
  number according to am equipartition in [0,1];
  making use of the ISAAC random number generator; C++ Implementation
  by Quinn Tyler Jackson of the RG invented by Bob Jenkins Jr.

--------------------------------------------------------------------------*/

#ifndef RANDOMGEN_H
#define RANDOMGEN_H

#include "ISAAC.h"
#include <ctime>
#include <climits>

class CRandomGen {
    private:
	QTIsaac<8, ulong> TheGen;

    public:
	explicit CRandomGen()	{ time_t t0 = time(NULL);
				  TheGen.srand( t0, t0 % 131313, t0 % 171717); }

	double n()		{ return TheGen.rand() / ULONG_MAX; }
};


extern CRandomGen __R;


class CRandomGen_std {
    private:
	double themax;

    public:
	explicit CRandomGen_std()	{ srand( time(NULL)), themax = RAND_MAX + 1.0; }
	double n()			{ return rand()/themax;  }
};

extern CRandomGen_std __R_std;

#endif

// EOF
