// ;-*-C++-*- *  Time-stamp: "2009-12-11 01:31:04 hmmr"

/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny
 *
 * License: GPL
 *
 * Initial version: 2008-09-23
 *
 * A base class for integrators, to be plugged into CModel
 */


#ifndef LIBCN_INTEGRATE_BASE_H
#define LIBCN_INTEGRATE_BASE_H

#include "config.h"

class CModel;

class CIntegrate_base {

//    friend class CModel;
//    protected:
    public:
	double	_dt_min, _dt_max;
	double	dt;  // that which is current

	bool	is_owned;

	CModel *model;

	CIntegrate_base( double indt_min, double indt_max,
			 bool inis_owned)
	      : _dt_min (indt_min), _dt_max (indt_max),
		dt (indt_min),
		is_owned (inis_owned)
		{}

	virtual void cycle() = 0;
	virtual void fixate() = 0;
	virtual void prepare() = 0;
};



#endif

// EOF
