// ;-*-C++-*- *  Time-stamp: "2009-12-11 01:31:04 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny
 *
 * License: GPL
 *
 * Initial version: 2008-09-23
 *
 * A Runge-Kutta 6-5 integrator
 */


#ifndef LIBCN_INTEGRATE_RK65_H
#define LIBCN_INTEGRATE_RK65_H

#include "config.h"

#include "integrate-base.h"
#include <vector>


class CIntegrateRK65
  : public CIntegrate_base {

	double	_dt_max_safeguard_factor,
		_eps, _eps_abs, _eps_rel;

    public:
	CIntegrateRK65( double indt_min = 1e-6, double indt_max = .5, double indt_max_safeguard_fac = 5,
			double ineps = 1e-8,  double inepsabs = 1e-12, double inepsrel = 1e-6,
			bool inis_owned = true)
	      : CIntegrate_base (indt_min, indt_max, inis_owned),
		_dt_max_safeguard_factor (indt_max_safeguard_fac),
		_eps (ineps), _eps_abs (inepsabs), _eps_rel (inepsrel)
		{}

	void cycle();
	void fixate();
	void prepare();

    private:
	std::vector<double> Y[9], F[9], y5;
};

#endif

// EOF
