// ;-*-C++-*- *  Time-stamp: "2009-12-11 01:31:03 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *
 * License: GPL
 *
 * Initial version: 2008-12-02
 *
 * An expression parser
 */

#ifndef CNAUX_EXPRPARSER_H
#define CNAUX_EXPRPARSER_H

#include <cmath>

enum TExprParserError {
	EXPARSE_OK = 0,
	EXPARSE_EMPTY,
	EXPARSE_UNBALANCED,
	EXPARSE_BAD
};

extern const char *const __exparse_error_strings[];

class CExpression {

	TExprParserError _status;

    public:
	CExpression()
		{	_status = EXPARSE_OK, _parsed_value = NAN;		}
	TExprParserError status()
		{	return _status;						}
	const char *error_string()
		{	return __exparse_error_strings[_status];		}

	double operator() ( const char *str)
		{	return ( _do_parse( str, _parsed_value) == EXPARSE_OK )
				? _parsed_value : NAN;				}
	int operator() ( const char *str, double& parsed)
		{	_do_parse( str, _parsed_value);
			parsed = _parsed_value;
			return _status;						}

    private:
	double	_parsed_value;
//	string	_source_str;
	TExprParserError _do_parse( const char *str, double& parsed);
};

#endif

// EOF
