// ;-*-C++-*- *  Time-stamp: "2009-12-11 01:31:04 hmmr"
/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *         building on original work by Thomas Nowotny (tnowotny@ucsd.edu)
 *
 * License: GPL
 *
 * Initial version: 2009-04-08
 *
 */


#include <iostream>
#include "param-unit-literals.h"
#include "standalone-synapses.h"
#include "types.h"
#include "model.h"


C_StandaloneSynapse::C_StandaloneSynapse( TUnitType intype, const char *inlabel,
					  C_BaseNeuron* insource, C_BaseNeuron* intarget,
					  CModel* inM, int s_mask)
      : C_BaseSynapse (intype, inlabel, insource, intarget, inM, s_mask),
	C_StandaloneAttributes (__CNUDT[intype].vno)
{
	reset_vars();
	if ( M )
		M->include_unit( this);
	// else
	// 	_status &= ~CN_UENABLED;
}


C_StandaloneSynapse::~C_StandaloneSynapse()
{
	if ( __cn_verbosely > 5 )
		fprintf( stderr, " deleting standalone synapse \"%s\"\n", label);
}

// C_StandaloneSynapse::~C_StandaloneSynapse()
// {
// 	if ( M->unregister_standalone_synapse( this) )
// 		cerr << "Synapse " << label << " was forgotten by mother model\n";
// }








const double __CN_Params_SynapseMap[] = {
	0.075,
       18.94463,  // Decay rate time constant
	0.25,
	0

};
const char* const __CN_ParamNames_SynapseMap[] = {
	"Synaptic strength g, " __CN_PU_CONDUCTANCE,
	"Decay rate time constant \317\204, " __CN_PU_RATE,
	"Release quantile \316\264",
	"Reversal potential Vrev, " __CN_PU_POTENTIAL
};
const char* const __CN_ParamSyms_SynapseMap[] = {
	"gsyn",
	"tau",
	"delta",
	"Vrev"
};

// const double __CN_Vars_SynapseMap[] = {
// 	0.,
// //	0.,
// };

// const char* const __CN_VarNames_SynapseMap[] = {
// 	"Amount of neurotransmitter released S",
// //	"Synaptic current",
// };
// const char* const __CN_VarSyms_SynapseMap[] = {
// 	"S",
// //	"Isyn"
// };







void
CSynapseMxMap::update_queue()
{
	enum TParametersSynapseMap {
		_gsyn_, _tau_, _delta_, _Vrev_
	};

	unsigned k = _source -> n_spikes_in_last_dt();
	while ( k-- )
		_kq.push_back( model_time());

	while ( true ) {
		if ( q() > 0 && model_time() - _kq.front() > P[_tau_] )
			_kq.erase( _kq.begin());
		else
			break;
	}
}


// EOF
