// ;-*-C++-*- *  Time-stamp: "2009-12-11 01:31:05 hmmr"

/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *
 * License: GPL
 *
 * Initial version: 2008-09-02
 *
 * libCN testing grounds evolving into a model runner
 */


#include <fstream>
#include <sys/stat.h>

#include "runner.h"

using namespace std;


vector<SParmValueBatch> Batches;




static unsigned run = 0;

// struct SCallable { void operator () (); };

// void
// SCallable::operator () ()
// {

// }


int
do_param_batch( unsigned ridx)
{
	if ( ridx < Batches.size() - 1 ) {
		SParmValueBatch &R = Batches[ridx];
		for ( R.value = R.min; R.value <= R.max; R.value += R.step ) {
			int retval = do_param_batch( ridx+1);
			if ( retval )
				return retval;
		}
	} else {
		SParmValueBatch &R = Batches[ridx];
		unsigned steps = (R.max-R.min)/R.step;
//		for ( R.value = R.min; R.value <= R.max; R.value += R.step ) {
		for ( unsigned itr = 0; itr <= steps; itr++ ) {
			R.value = R.min + itr*R.step;
			cout << "\n=========== Run " << ++run << ", with values:\n";
			string dirname;
			char _[16];
//			snprintf( _, 9, "%05d", run);
			for ( unsigned i = 0; i < Batches.size(); i++ ) {
				snprintf( _, 15, "%s%9.7f", i ?"-" :"", Batches[i].value);
				dirname += _;
			}
			mkdir( dirname.data(), S_IRWXU|S_IRWXG|S_IROTH|S_IXOTH);
			if ( chdir( dirname.data()) == -1 ) {
				cerr << "Failed to create or enter dir \"" << dirname << "\"\n";
				continue;
			}

			for ( vector<SParmValueBatch>::iterator Q = Batches.begin(); Q != Batches.end(); Q++ )
				cout << (*Q).unit->label << "{" << (*Q).unit->param_sym( (*Q).parm) << "} = "
				     << (*Q).value << endl;

			assign_unit_current_range_values();
			Model->reset();
			Model->advance( Options.running_time);

			if ( chdir( "..") )
				;
		}
		cout << endl;
	}
	return 0;
}









void
assign_unit_current_range_values()
{
	vector<SParmValueBatch>::iterator R;
	for ( R = Batches.begin(); R != Batches.end(); R++ )
		switch ( R->kind ) {
		case C_BaseUnit::RDA_PARAM:	R->unit->param_value(R->parm) = R->value;	break;
		case C_BaseUnit::RDA_VAR:      	R->unit->  var_value(R->parm) = R->value;	break;
		default:;
		}
}


// EOF
