// ;-*-C++-*- *  Time-stamp: "2009-12-20 17:38:30 hmmr"

/*
 * Author: Andrei Zavada (a.zavada@sussex.ac.uk)
 *
 * License: GPL
 *
 * Initial version: 2008-09-02
 *
 * CNModel runner (dump_model_units)
 */


#include <set>
#include "pointaligned-s.h"
#include "base-unit.h"
#include "types.h"
#include "runner.h"

void
dump_model_units()
{
	cout << "\nUnit types in the model:\n";

	set<int> found_unit_types;
	unsigned p = 0;

	cout << "\n===== Neurons:\n";
	for_model_units (Model,U)
		if ( (*U)->is_neuron() && found_unit_types.count( (*U)->type()) == 0 ) {
			found_unit_types.insert( (*U)->type());

			printf( "--- %s: %s\nParameters: ---\n",
				(*U)->type_name(), (*U)->type_description());
			for ( p = 0; p < (*U)->p_no(); p++ ) {
				printf( "%2d: %-5s\t= %s %s\n",
					p, (*U)->param_sym(p),
					double_dot_aligned_s( (*U)->param_value(p), 4, 6),
					(*U)->param_name(p));
			}
			printf( "Variables: ---\n");
			for ( p = 0; p < (*U)->v_no(); p++ ) {
				printf( "%2d: %-5s\t= %s %s\n",
					p, (*U)->var_sym(p),
					double_dot_aligned_s( (*U)->var_value(p), 4, 6),
					(*U)->var_name(p));
			}

		}
	cout << "\n===== Synapses:\n";
	for_model_units (Model,U)
		if ( (*U)->is_synapse() && found_unit_types.count( (*U)->type()) == 0 ) {
			found_unit_types.insert( (*U)->type());

			printf( "--- %s: %s\nParameters: ---\n",
				(*U)->type_name(), (*U)->type_description());
			printf( "    parameters:\n");
			for ( p = 0; p < (*U)->p_no(); p++ ) {
				printf( "%2d: %-5s\t= %s %s\n",
					p, (*U)->param_sym(p),
					double_dot_aligned_s( (*U)->param_value(p), 4, 6),
					(*U)->param_name(p));
			}
			printf( "Variables: ---\n");
			for ( p = 0; p < (*U)->v_no(); p++ ) {
				printf( "%2d: %-5s\t= %s %s\n",
					p, (*U)->var_sym(p),
					double_dot_aligned_s( (*U)->var_value(p), 4, 6),
					(*U)->var_name(p));
			}

		}
	cout << endl;
}







// void
// report_spike_count_stats()
// {
// 	if ( strcmp( Options.spike_cnt_stats_file, "-") ) {
// 		ofstream report_stream( Options.spike_cnt_stats_file);
// 		report_stream <<
// 			"#Label\tTimes Spiked\n";

// 		for_model_spikelogging_neurons (Model,N)
// 			report_stream << (*N)->label << '\t' << (*N)->spike_cnt << endl;
// 	} else {
// 		cout <<
// 			"------- Spiking stats:\n"
// 			"Label\tTimes Spiked\n";

// 		for_model_spikelogging_neurons (Model,N)
// 			printf( "%-20s\t%ld\n", (*N)->label, (*N)->spike_cnt);
// 	}
// }


// EOF
