// ;-*-C++-*- *  Time-stamp: "2008-10-15 16:14:47 hmmr"
//--------------------------------------------------------------------------
// Author: Thomas Nowotny
//
// Institute: Institute for Nonlinear Dynamics
//            University of California San Diego
//            La Jolla, CA 92093-0402
//
// email to:  tnowotny@ucsd.edu
//
// initial version: 2005-08-17
//
//--------------------------------------------------------------------------


#ifndef CN_NEURONSMPLTAPE_H
#define CN_NEURONSMPLTAPE_H

#include "cnlib-unit.h"


extern const double __CN_Vars_NeuronReader[];
extern const char* const __CN_VarNames_NeuronReader[];
extern const char* const __CN_VarSyms_NeuronReader[];



class CNReader
  : public CNeuron {

    public:
	CNReader( const char *inlabel,
			   const char *fname,
			   double intimestep,
			   int instatus = CN_SMPLTAPE_LOOP);

       ~CNReader();

	virtual double &param_value( size_t idx)
		{
			return __cn_dummy_double;
		}
	virtual void reset_params()
		{
		}

	virtual void possibly_fire();

	virtual void derivative( vector<double>& u, vector<double>& uu)
		{}
	virtual void noise()
		{}

    private:
	vector<double> Et;
	double _timestep;

	double next_state_E;
};

#endif

// EOF
