// ;-*-C++-*- *  Time-stamp: "2008-10-14 02:45:12 hmmr"
/*--------------------------------------------------------------------------
   Author: Thomas Nowotny

   Institute: Institute for Nonlinear Dynamics
	      University of California San Diego
	      La Jolla, CA 92093-0402

   email to:  tnowotny@ucsd.edu

   initial version: 2005-08-17

--------------------------------------------------------------------------*/

#ifndef CN_TYPES_H
#define CN_TYPES_H


typedef enum {
      // neuron types
	NT_VOID = -1,
	NT_TICKER,
	NT_READER,

	NT_HH,
	NT_TM,
	NT_EC,
	NT_ECA,

	NT_POISSON,  // these two use RandomGen
	NT_LV,
	NT_COLPITTS,
	NT_VDPOL,

      // synapse types
	YT_AB,
	YT_OSCILTUNER,
} TUnitType;


#define NT_FIRST NT_TICKER
#define NT_LAST  NT_VDPOL
#define YT_FIRST YT_AB
#define YT_LAST  YT_OSCILTUNER



struct SCNDescriptor {
	int	pno,
		vno;
	const double	*const  stock_param_values;
	const char	*const *stock_param_names;
	const char	*const *stock_param_syms;
	const double	*const  stock_var_values;
	const char	*const *stock_var_names;
	const char	*const *stock_var_syms;
	const char	*label;
	const char	*name;
};


extern SCNDescriptor __CN_DescriptorTable[];

void cnmodel_dump_available_units();


#endif
